
var cgiGotoPage; 
if (gs.cgiParams["gp"]) {
    cgiGotoPage = Number(gs.cgiParams["gp"]);
}
else {
    cgiGotoPage = 1;
}

var expeditee; 
if (gs.cgiParams["expeditee"] == "1") {
    expeditee = true;
}
else {
    expeditee = false;
}


var musicStand 
    = new MusicStand(httpdocument, gs.cgiParams["c"], gs.cgiParams["d"], gs.documentMetadata["assocfilepath"],
		     Number(gs.cgiParams["numPages"]), cgiGotoPage, 
		     Number(gs.cgiParams["pageWidth"]), Number(gs.cgiParams["pageHeight"]),
		     Number(gs.cgiParams["scaleFactor"]));

musicStand.setStyleColors(gs.variables["postitBgCol"],gs.variables["postitSelCol"]);

musicStand.setPagePrefix(gs.cgiParams["pagePrefix"]);
musicStand.setPageSuffix(gs.cgiParams["pageSuffix"]);

var annotate = new Annotate(gs.variables.httpCollectionImages);

if (gs.userInformation && gs.userInformation.username) {
  musicStand.setUsername(gs.username);
  annotate.setUsername(gs.username);
}

//  de.events.addLoadHandler(function()

$(window).load(function(){
      try {
	  bodyLoaded();                       
      } 
      catch(err) {
	  alert("musicstand-main.js: Failed to initialise: " + err.message);
      }
});


function getElementsByClass(searchClassPrefix,node,tag) {
    
    var classElements = new Array();
    if ( node == null )
	node = document;
    if ( tag == null )
	tag = '*';
    
    if (node.getElementsByTagName) {
	var els = node.getElementsByTagName(tag);
	
  	var elsLen = els.length;
	var pattern = new RegExp('(^|\\s)'+searchClassPrefix);
	for (var i = 0, j = 0; i < elsLen; i++) {
	    if ( pattern.test(els[i].className) ) {
		classElements[j] = els[i];
		j++;
	    }
	}
    }
    return classElements;
}



var dotsTimer = null;
var dotsDelta = 200;

function dotsAnim(numDots)
{
  var dots = [ "", ".", "..", "..." ];

  var dotSpan = document.getElementById('loadingdots');
  dotSpan.innerHTML = "loading " + dots[numDots];

  var nextNumDots = (numDots+1) %4;
  dotsTimer = setTimeout("dotsAnim("+nextNumDots+")",dotsDelta);
}


function bodyLoaded()
{
  // load page 1
  var thisPageImg = document.getElementById("thispageimg");

  var thisPageUrl = musicStand.httpnextanim(gs.cgiParams["pagePrefix"],gs.cgiParams["pageSuffix"],musicStand.getPageNum());

  var thisImg = document.createElement('img');
  thisImg.onload = function (evt) {
      var annotateCanvasElem = document.getElementById("annotateCanvas");
      annotateCanvasElem.style.display = "none";

      annotate.loadAnnotations(musicStand.getDocOID());

      var thisLoading = document.getElementById("loading");
      thisLoading.style.display = "none";
      if (dotsTimer != null) {
        clearTimeout(dotsTimer);
      }
      thisPageImg.src = thisImg.src;

      annotateCanvasElem.style.display = "block";
  }

  //alert("**** thisPageUrl = " + thisPageUrl);

  thisImg.src = thisPageUrl;
  // thisPageImg.src = thisPageUrl;

  // setup page 2 as next page
  var nextPageImg = document.getElementById("nextpageimg");
  var nextPageImg_LR = document.getElementById("nextpage-lr-img");
  var nextPageUrl = musicStand.httpnextanim(gs.cgiParams["pagePrefix"],gs.cgiParams["pageSuffix"],musicStand.getPageNum()+1);

  //var nextImg = document.createElement('img');
  ////nextImg.onload = function (evt) {
  ////nextPageImg.onload = function (evt) {
  ////    
  ////}
  nextPageImg.src = nextPageUrl;
  nextPageImg_LR.src = nextPageUrl;

    if (musicStand.getPageNum()>1) {
	// setup previous page, as page-1
	var prevPageImg = document.getElementById("prevpageimg");
	var prevPageUrl = musicStand.httpprevanim(gs.cgiParams["pagePrefix"],gs.cgiParams["pageSuffix"],musicStand.getPageNum()-1);

	//var prevImg = document.createElement('img');
	prevPageImg.src = prevPageUrl;
    }
    
    // some browsers clear clip rectangle with new image => set it to what we need
  var clip_str = "rect(0px, "+gs.cgiParams["pageWidth"]+"px, "+gs.cgiParams["pageHeight"]+"px, "+gs.cgiParams["pageWidth"]+"px)";
    
  var nextpagediv = document.getElementById("nextpagediv");
  nextpagediv.style.clip = clip_str;
  var nextpagediv_lr = document.getElementById("nextpage-lr-div");
  nextpagediv_lr.style.clip = clip_str;

  var prevpagediv = document.getElementById("prevpagediv");
  prevpagediv.style.clip = clip_str;
  var prevpagediv_lr = document.getElementById("prevpage-lr-div");
  prevpagediv_lr.style.clip = clip_str;

  var animedgebleed = document.getElementById("animedgebleed");
  animedgebleed.style.clip = clip_str;
  var animedgebleed_lr = document.getElementById("animedgebleed-lr");
  animedgebleed_lr.style.clip = clip_str;

  // no previous page to set up

  // start loading dots
  dotsTimer = setTimeout("dotsAnim(0)",dotsDelta);


    var thispage = document.getElementById("thispage");

  //YAHOO.util.Event.addListener("thispage", 'mouseover', trackMouse);
  // YAHOO.util.Event.addListener(document, 'mousemove', trackMouse);

    //de.events.addMouseMoveHandler(trackMouse);
    de.events.addHandler(document,"mousemove",trackMouse);

  // de.events.prependMouseUpHandler(musicStand.pageMenu);

  //YAHOO.util.Event.addListener(document, 'keydown', keyPress);

    //de.events.prependKeyPressHandler(keyPress);
    //de.events.addHandler(document,"keypress",keyPress);
    de.events.addHandler(document,"keystroke",keyPress);

    //de.events.addHandler(thispage,"keystroke",keyPress);

    //thispage.addEventListener("keydown", keyPress);
    //thispage.addEventListener("keypress", keyPress);


    //var gotoNavBar = document.getElementById("gotoNavBar");
    //gotoNavBar.addEventListener("keydown", keyPress);
    //gotoNavBar.addEventListener("keypress", keyPress);

    //$('#gotoNavBar').bind('keydown',keyPress);
    //$('#gotoNavBar').focus();
		     
    
    //YAHOO.util.Event.addListener("thispage", 'keydown', keyPress);
    
}


var sliderMoving = false;

var prevOnMouseMove = null;
var prevOnMouseUp   = null;

function dragSlider(evt)
{
    evt = evt || window.event;

    evt.returnValue = false;
    if (evt.preventDefault) evt.preventDefault();

    sliderMoving = true;
    moveSlider(evt);

    prevOnMouseMove = document.onmousemove;
    prevOnMouseUp   = document.onmouseup;

    document.onmousemove = moveSlider;
    document.onmouseup = releaseSlider;
}



function moveSlider(evt)
{
    if (!sliderMoving) return;

    evt = evt || window.event;

    evt.returnValue = false;
    if (evt.preventDefault) evt.preventDefault();

    var mousePos = getMouseCoords(evt);

    var sliderContainer = document.getElementById('slidercontainer');
    var sliderContainerYTop = getAbsoluteTop(sliderContainer);
    var sliderContainerHeight = getRectHeight(sliderContainer) -1;

    var slider = document.getElementById('sliderpos');
    var sliderHeight = getRectHeight(slider);
    
    var halfSliderHeight = sliderHeight/2;
    var newSliderTop = (mousePos.y - sliderContainerYTop) - halfSliderHeight;

    if ((newSliderTop >= 0) 
        && (newSliderTop < (sliderContainerHeight-halfSliderHeight))) {
        slider.style.top = newSliderTop + "px";
        var speedBreak = newSliderTop;
	musicStand.setSpeedBreak(speedBreak);

	var trackabove = document.getElementById('slidertrackabove');
	trackabove.style.height = speedBreak + "px";

	var trackbelow = document.getElementById('slidertrackbelow');
	trackbelow.style.top = speedBreak + "px";
	trackbelow.style.height = (Number(gs.cgiParams["pageHeight"]) - speedBreak) + "px";

    }

}


function releaseSlider(evt)
{
    if (!sliderMoving) return;

    document.onmousemove = prevOnMouseMove;
    document.onmouseup = prevOnMouseUp;

    sliderMoving = false;  

    var slider = document.getElementById('sliderpos');
    var sliderposTop = parseInt(slider.style.top);

    if (sliderposTop>0) {
        sliderposTop /= musicStand.getScaleFactor();
    }


    var docid = musicStand.getDocRoot() + "." + musicStand.getPageNum(); 

    var username = musicStand.getUsername();
    var metaname = (username!=null) ? username + "-sliderposTop" : "sliderposTop";
    //gsapi.setLiveMetadata(docid,metaname,sliderposTop);
    //alert("Need to set slider");
}


function updateSlider(sliderposTop)
{
    if (sliderposTop>0) {
        sliderposTop *= musicStand.getScaleFactor();

    }
    var speedBreak = sliderposTop;
    musicStand.setSpeedBreak(speedBreak);

    var sliderpos = document.getElementById('sliderpos');
    sliderpos.style.top = speedBreak + "px";
    sliderpos.style.left = "-8px";

    var trackabove = document.getElementById('slidertrackabove');
    trackabove.style.height = speedBreak + "px";

    var trackbelow = document.getElementById('slidertrackbelow');
    trackbelow.style.top = speedBreak + "px";
    trackbelow.style.height = (Number(gs.cgiParams["pageHeight"]) - speedBreak) + "px";
}

