
  var GUITopGap = 135;
  var GUIBotGap =  30;
  var GUILeftRightGap = 60; // used to be 80

  function openMusicStand(docid,pagePrefix,pageSuffix,numPages,maxPageWidth,maxPageHeight)
  {

    var screenWidth; 
    var screenHeight;

    var widthRatio;
    var heightRatio;
    
    var ratio;

    var pageWidth;
    var pageHeight;

    var musicStandWidth;
    var musicStandHeight;


    if (orientation == "landscape") {
        screenWidth = screen.height - GUILeftRightGap; // leave some wiggle room
        screenHeight = screen.width - GUITopGap - GUIBotGap; // leave some wiggle room


        widthRatio = screenWidth / maxPageWidth;
        heightRatio = screenHeight / maxPageHeight;
    
        ratio = (widthRatio<heightRatio) ? widthRatio : heightRatio;

        pageHeight = Math.round(maxPageWidth * ratio);
        pageWidth = Math.round(maxPageHeight * ratio);

        musicStandWidth = pageWidth + GUILeftRightGap;
        musicStandHeight = pageHeight + GUITopGap + GUIBotGap;
    
    }
    else {
        screenWidth = screen.width - GUILeftRightGap; // leave some wiggle room
        screenHeight = screen.height - GUITopGap - GUIBotGap; // leave some wiggle room

        widthRatio = screenWidth / maxPageWidth;
        heightRatio = screenHeight / maxPageHeight;
    
        ratio = (widthRatio<heightRatio) ? widthRatio : heightRatio;

        pageWidth = Math.round(maxPageWidth * ratio);
        pageHeight = Math.round(maxPageHeight * ratio);

        musicStandWidth = pageWidth + GUILeftRightGap;
        musicStandHeight = pageHeight + GUITopGap + GUIBotGap;

    }


    //var url = "_httpdocument_&d=" + docid + "&view=simple";
    var url = "?a=d&ed=1&book=off&c="+gs.cgiParams["c"]+"&d=" + docid + "&excerptid=gs-document-text&view=simple";
    var url = httpdocument + "&d=" + docid + "&excerptid=gs-document-text&view=simple";
    url += "&pagePrefix="+pagePrefix;
    url += "&pageSuffix="+pageSuffix;
    url += "&numPages="+numPages;
    url += "&pageWidth="+pageWidth+"&pageHeight="+pageHeight;
    url += "&pageWidthWithBreakbar="+pageWidth+(GUILeftRightGap/2);
    url += "&musicStandWidth="+musicStandWidth+"&musicStandHeight="+musicStandHeight;
    url += "&scaleFactor="+ratio;


    var options = 'toolbar=0,menubar=0,location=0,directories=0,scrollbars=0,status=1';
    options += ',width='+musicStandWidth+',height='+musicStandHeight;

    //var options = 'toolbar=no, menubar=no, location=no, scrollbars=no, status=yes';
    //options += ', width='+musicStandWidth+', height='+musicStandHeight;

    // The following worked in MS-Edge
    //var options = 'height='+Number(musicStandHeight-340)+', width='+musicStandWidth; 
    //options += ', status=yes, toolbar=no, menubar=no, location=no';

    //var options = "height=600, width=400, status=yes, toolbar=no, menubar=no, location=no";

    console.log("Opening new window with options:" + options);
      
    window.open(url, 'musicstand', options);
    //window.open(url, null, options);
    //window.open("Sample.htm", null, "height=600, width=400, status=yes, toolbar=no, menubar=no, location=no");
      
    return false;
  }

